#!/bin/bash

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  #
#			  Última actualización: 21-enero-2019		    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	    		    #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.								    #
#									    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.							    #
#									    #
############################################################################# 
# autor: Charles Escobar
# sitio: http://www.gradio.net
# fecha: 14/08/2019
# ver: 1.0 RC 
# Script para automatizar G-Radio
# G Radio bash module  -v 4.0 name: Ébano

echo "Cargando.." > $HOME/.gradio/data/tmp/avance
echo "Cargando" > $HOME/.gradio/data/tmp/avanceweb
echo "Modo Automático" > $HOME/.gradio/data/tmp/currentcomercial.txt;

############# CONDICIONES INICIALES #########################################
device=`cat $HOME/.gradio/data/devmain`
echo 0 > $HOME/.gradio/data/tmp/eventosplay
echo "0" > $HOME/.gradio/data/tmp/stopGR4
echo $$ > $HOME/.gradio/data/pid
if [[ ! -d $HOME/.gradio/data/tmp/intercarpetas ]]; then
	mkdir $HOME/.gradio/data/tmp/intercarpetas
fi
if [[ ! -p $HOME/.gradio/data/tmp/par.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/par.fifo
fi
if [[ ! -p $HOME/.gradio/data/tmp/efecto.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/efecto.fifo
fi
if [[ ! -p $HOME/.gradio/data/tmp/impar.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/impar.fifo
fi
if [[ ! -p $HOME/.gradio/data/tmp/imparcom.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/imparcom.fifo
fi
if [[ ! -p $HOME/.gradio/data/tmp/parcom.fifo ]]; then
	mkfifo $HOME/.gradio/data/tmp/parcom.fifo
fi
if [[ ! -f $HOME/.gradio/data/tmp/temacounter ]]; then
	echo 0 > $HOME/.gradio/data/tmp/temacounter
fi
if [[ ! -f $HOME/.mplayer/config  ]]; then
	mkdir $HOME/.mplayer 
	echo "# Write your default config options here!" > $HOME/.mplayer/config 
	echo "softvol=true" >> $HOME/.mplayer/config 
	echo "ao=pulse" >> $HOME/.mplayer/config 
else
	softvol=`grep "softvol=true" $HOME/.mplayer/config`
	aopulse=`grep "ao=pulse" $HOME/.mplayer/config`
	if [[ $softvol = "" ]];then
		echo "softvol=true" >> $HOME/.mplayer/config 
	fi
	if [[ $aopulse = "" ]];then
		echo "ao=pulse" >> $HOME/.mplayer/config 
	fi
fi
####################################################
function tiempo() {
duracion=`mplayer -ao null -identify -frames 0 "$1" 2>&1 | grep ID_LENGTH|awk -F"=" '{print $2}'|awk -F "." '{print $1}'`
echo "00:00:$duracion" > $HOME/.gradio/data/tmp/duracion
segundos=$duracion
return $segundos
}
###############INICIO PROGRAMA######################
daemon=`ps -x|grep -v grep|grep .gradio/bin/comercialdaemon.sh`
if [[ $daemon != "" ]];then
	killall -9 comercialdaemon.sh
fi
daemon=`ps -x|grep -v grep|grep .gradio/bin/comercialdaemon4.sh`
if [[ $daemon != "" ]];then
	killall -9 comercialdaemon4.sh
fi
daemon=`ps -x|grep -v grep|grep .gradio/bin/cargalista.sh`
if [[ $daemon != "" ]];then
	killall -9 cargalista.sh
fi
semiautomatico=`cat $HOME/.gradio/data/tmp/listavacia`
daemon=`ps -x|grep -v grep|grep .gradio/bin/cargalista4.sh`
if [[ $daemon != "" && $semiautomatico = 0 ]];then
	killall -9 cargalista4.sh
fi

mascara=`ps uax|grep GMain.gambas|grep -v grep`

#Vaciar eventos
cat /dev/null > $HOME/.gradio/data/tmp/eventoslist
cat /dev/null > $HOME/.gradio/data/tmp/eventoslistweb
cat /dev/null > $HOME/.gradio/data/tmp/eventoslistwebg3
sed -i "1d" $HOME/.gradio/data/tmp/eventoslist
sed -i "1d" $HOME/.gradio/data/tmp/eventoslistweb
sed -i "1d" $HOME/.gradio/data/tmp/eventoslistwebg3

semiautomatico=`cat $HOME/.gradio/data/tmp/listavacia`
y=`ps -e |grep cargalista4.sh`
if [[ $y = "" && $semiautomatico = 0 ]]; then
	$HOME/.gradio/bin/cargalista4.sh & 
fi

z=`ps -uax |grep comercialdaemon4.sh|grep -v grep`
if [ "$z" = "" ]; then 
	$HOME/.gradio/bin/comercialdaemon4.sh & 
fi
#sleep 1 #Tiempo para que el cargalista cargue el playlist
echo "Listo!" > $HOME/.gradio/data/tmp/avance
echo "Listo!" > $HOME/.gradio/data/tmp/avanceweb
salir=0
saliolazo=0
#################################################
while [ $salir=0 ]; do
	minini=`date  +%-M`
	hini=`date +%-H`
	hora=`date  +%-H` 
	dia=`date +%u`
	minuto=`date +%-M`
	previo="inicio"
	ranura=`echo "$hora-$(($hora+1)).mus"`
	echo 0 > $HOME/.gradio/data/tmp/repitiendo
	echo "Mensajes auxiliares GR" > $HOME/.gradio/data/tmp/currentcomercial.txt
	echo "Visor de Temas Musicales" > $HOME/.gradio/data/tmp/currentsong.txt
	caracteres=`wc -m $HOME/.gradio/data/parrilla/$dia/$ranura|cut -d " " -f 1`
	nlineas=`grep -c $ $HOME/.gradio/data/tmp/playlist4`
	hora1=`date  +%-H` 
	while [ $hora = $hora1 ]; do 
		nlineas=`grep -c $ $HOME/.gradio/data/tmp/playlist4`
		temacounter=`cat $HOME/.gradio/data/tmp/temacounter`
		device=`cat $HOME/.gradio/data/devmain`

		###echo "#########################PARRILLA MUSICAL#####################################################"

		if [[ $nlineas -ge 1 ]]; then		
			nlinea=1 
			while [ $nlinea -le $nlineas ]; do
				device=`cat $HOME/.gradio/data/devmain`				
				estadotv=`cat $HOME/.gradio/data/tmp/tvestado`
				desplazamiento=`cat $HOME/.gradio/data/tmp/tvdesplazamiento`
				teletexto=`cat $HOME/.gradio/data/tmp/teletexto`
				if [[ $estadotv = 1 ]]; then
					tvopcion="-fs -geometry $desplazamiento"
				else
					tvopcion="-novideo"
				fi
				srt=$HOME/.gradio/data/tmp/teletexto.srt
				color=`cat $HOME/.gradio/data/tmp/teletexto.color`
				if [[ $estadotv = 1 && $teletexto = 1 ]]; then
					srtopcion="-utf8 -sub $srt $color "
				else
					srtopcion=""
				fi
				randomfile=`sed -n 1p $HOME/.gradio/data/tmp/playlist4|sed '$s/\(^[^\t]*\).*$/\1/'`
				url_str=`sed -n 1p $HOME/.gradio/data/tmp/playlist4`
				sed -i "1d" $HOME/.gradio/data/tmp/playlist4  
				nombrebase=`echo "$randomfile" |awk -F/ '{print $NF}'`
				musini=`date +%s`	
				musinicio=`date +%H:%M:%S`				
				temacounter=$(( $temacounter + 1 ))
				echo $temacounter > $HOME/.gradio/data/tmp/temacounter			
				espar=$(( $temacounter % 2))
				$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas
				if [[ $espar == 0 ]]; then
					fifofile="$HOME/.gradio/data/tmp/par.fifo"
					porc="par"
				else
					fifofile="$HOME/.gradio/data/tmp/impar.fifo"
					porc="impar"
				fi
				echo "$fifofile" > $HOME/.gradio/data/tmp/fifofile
				volup=`cat  $HOME/.gradio/data/tmp/upvol`
				voldown=`cat  $HOME/.gradio/data/tmp/downvol`
				
				PlugLineInGRadio=`echo $url_str|grep LineInGradio|awk -F" " '{ print $NF }'`
				#echo "PlugLineInGRadio: $PlugLineInGRadio"
				if [[ $PlugLineInGRadio -gt 0 ]]; then	
					echo "Reproduciendo PlugLineInGRadio" > $HOME/.gradio/data/tmp/currentsong.txt 
					#echo "Reproduciendo PlugLineInGRadio" > $HOME/.gradio/data/tmp/currentsongweb				
					pactl load-module module-loopback latency_msec=5
					echo "00:00:$PlugLineInGRadio"  > $HOME/.gradio/data/tmp/duracion
					$HOME/.gradio/bin/countdown.sh &
					sleep $PlugLineInGRadio
					pactl unload-module module-loopback
				fi
				
				
				if [[ $randomfile = "Hora" && $previo != "$randomfiles" ]]; then	
					twitter=`cat $HOME/.gradio/data/tmp/twidge`
					mix=`cat $HOME/.gradio/data/mix.txt`
					nombrebase="Hora"
					echo "Hora" > $HOME/.gradio/data/tmp/currentsong.txt 
					#echo "Hora" > $HOME/.gradio/data/tmp/currentsongweb
					echo "0" > $HOME/.gradio/data/tmp/porciento
					if [[ $twitter = 1 ]]; then 
						echo "Ahora emitiendo la hora"|twidge update & 
					fi
					echo "Hora" > $HOME/CurrenSong.txt
					cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
					if [[ $cdown != "" ]]; then
						killall -9 countdown.sh
					fi
					echo "Hora" > $HOME/.gradio/data/tmp/avance
					echo "<font color='red' size='24'><b>Hora</b></font>" > $HOME/.gradio/data/tmp/avanceweb
					sleep 0.1
					$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
					desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
					if [[ $desiguiente = 0 && $mix > 1 ]]; then
						sleep $(($mix-2)) 
					fi
					xterm -iconic  -fg Green -bg DarkBlue -title "hora" -geometry 40x1-0+0  -e $HOME/.gradio/data/panel/hora.sh
					previo="$randomfile"
					desiguiente=0
					modo=`cat $HOME/.gradio/data/tmp/modo`
					if [[ $modo = 0 ]]; then
						sleep $mix
						$HOME/.gradio/bin/detenermanual4.sh GR4
					fi
				else 
					url_streaming=`echo $randomfile|grep "http://"`
					url_streamings=`echo $randomfile|grep "https://"`
					if [[ $url_streamings != "" || $url_streaming != "" && $previo != "$randomfiles" ]]; then	
						twitter=`cat $HOME/.gradio/data/tmp/twidge`
						mix=`cat $HOME/.gradio/data/mix.txt`
						nombrebase="$url_streaming"
						duracion_url=`echo $url_str|awk -F " " '{print $2}'`
						streaming_url=`echo $url_str|awk -F " " '{print $1}'`
						echo "duracion_url: $duracion_url, streaming_url: $streaming_url"
						echo "$url_streaming" > $HOME/.gradio/data/tmp/currentsong.txt 
						#echo "$url_streaming" > $HOME/.gradio/data/tmp/currentsongweb
						if [[ $twitter = 1 ]]; then 
							echo "Ahora emitiendo $url_streaming"|twidge update & 
						fi
						echo "$url_streaming" > $HOME/CurrenSong.txt
						cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
						if [[ $cdown != "" ]]; then
							killall -9 countdown.sh
						fi
						echo "00:00:$duracion_url" > $HOME/.gradio/data/tmp/duracion
						echo "<font color='red' size='24'><b>$url_streaming</b></font>" > $HOME/.gradio/data/tmp/avanceweb
						sleep 0.1
						$HOME/.gradio/bin/countdown.sh &
						$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
						desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
						if [[ $desiguiente = 0 && $mix > 1 ]]; then
							sleep $(($mix-2)) 
						fi
						xterm -iconic  -fg Green -bg DarkBlue -title "Cadena de Streaming" -geometry 40x1-0+0  -e timeout $duracion_url mplayer $device -slave -input file="$fifofile" $streaming_url > $HOME/.gradio/data/tmp/mstatus
						.  $HOME/.gradio/bin/panico.sh &
						previo="$randomfile"
						desiguiente=0
						modo=`cat $HOME/.gradio/data/tmp/modo`
						if [[ $modo = 0 ]]; then
							sleep $mix
							$HOME/.gradio/bin/detenermanual4.sh GR4
						fi
				fi 
				playinginter=0
				if [[ -s "$randomfile" ]]; then ## Verifica que existe el randomfile
				
					novacio=`[ "$(ls -A $HOME/.gradio/data/tmp/intercarpetas)" ] && echo "1" || echo "0"`
					if [[ $novacio = "1" ]];then
					intercultural=`echo "$randomfile"|grep -f $HOME/.gradio/data/tmp/intercarpetas`
					fi					
					
					if [[ $intercultural != "" ]]; then
						echo "Ini Intercultural" > $HOME/.gradio/data/tmp/avance
						echo "Intro Intercultural" > $HOME/.gradio/data/tmp/currentsong.txt
						echo "<font color='red' size='24'><b>Ini Publicidad</b></font>" > $HOME/.gradio/data/tmp/avanceweb
						playinginter=1
						$HOME/.gradio/data/panel/playiniciointer.sh
					fi
					echo "${nombrebase%.*}" > $HOME/.gradio/data/tmp/currentsong.txt
					echo "${nombrebase%.*}" > $HOME/CurrentSong.txt
					twitter=`cat $HOME/.gradio/data/tmp/twidge`
					if [[ $twitter = 1 ]]; then 
						echo "Ahora emitiendo $nombrebase"|twidge update &
					fi
					nowplaying=`cat $HOME/.gradio/data/tmp/nowplaying`
					server=`cat $HOME/.gradio/data/tmp/darkice.conf |grep server|awk -F"= " '{ print $2 }'|sed s/" "//g`
					if [[ $nowplaying = 1 && $server != "server.com"  ]]; then
						password=`cat $HOME/.gradio/data/tmp/darkice.conf |grep password|awk -F"= " '{ print $2 }'|sed s/" "//g`
						mountp=`cat $HOME/.gradio/data/tmp/darkice.conf |grep mountPoint|awk -F"= " '{ print $2 }'|sed s/" "//g`
						userd=`cat $HOME/.gradio/data/tmp/icesuser`
						server=`cat $HOME/.gradio/data/tmp/darkice.conf |grep server|awk -F"= " '{ print $2 }'|sed s/" "//g`
						port=`cat $HOME/.gradio/data/tmp/darkice.conf |grep port|awk -F"= " '{ print $2 }'|sed s/" "//g`
						wget "http://$userd:$password@$server:$port/admin/metadata?mount=%2F$mountp&mode=updinfo&song=${nombrebase%.*}" -O $HOME/.gradio/data/tmp/tegw &
					fi
					#echo "<font size="1" color="red"><b>${nombrebase%.*}</b></font>" > $HOME/.gradio/data/tmp/currentsongweb
					if [[ `cat $HOME/.gradio/data/tmp/mezcla` = 1 ]]; then  #Fundido
						if [[ `cat $HOME/.gradio/data/tmp/pisador` = 1 && $intercultural = "" ]]; then 
							avanti=`echo "$randomfile"|grep -i avance`
							if [ "$avanti" = "" ]; then 
								if [[  $line != "Hora" ]]; then 
									xterm -iconic  -fg Black -bg Yellow -title "Pisador" -geometry 40x1+0+0 -e $HOME/.gradio/data/panel/pisador.sh & 
								fi
							fi
						fi  
						minini=`date  +%-M`
						echo $randomfile > $HOME/.gradio/data/tmp/repite
						echo "#!/bin/bash" > $HOME/.gradio/data/tmp/repitetmp.sh
						echo "killall -9 countdown.sh" >> $HOME/.gradio/data/tmp/repitetmp.sh
						echo "$HOME/.gradio/bin/countdown.sh &" >> $HOME/.gradio/data/tmp/repitetmp.sh
						echo "mplayer $device $tvopcion -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  $srtopcion -volume $volup -quiet -slave -input file="$fifofile"  \"$randomfile\" > $HOME/.gradio/data/tmp/mstatus$porc" >> $HOME/.gradio/data/tmp/repitetmp.sh
						echo "echo "0" > $HOME/.gradio/data/tmp/repitiendo" >> $HOME/.gradio/data/tmp/repitetmp.sh
						chmod 755 $HOME/.gradio/data/tmp/repitetmp.sh
						tiempo "$randomfile"
						cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
						if [[ $cdown != "" ]]; then
							killall -9 countdown.sh
						fi
						sleep 0.2
						$HOME/.gradio/bin/countdown.sh &
						echo $espar > $HOME/.gradio/data/tmp/espar
						mplayer $device $tvopcion $srtopcion -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  -volume $volup -quiet -slave -input file="$fifofile"  "$randomfile"  > $HOME/.gradio/data/tmp/mstatus$porc 2>&1 & echo $! > $HOME/.gradio/data/tmp/parrilla.pid
					        logo=`cat $HOME/.gradio/data/tmp/tvlogo`

						ruta=`dirname "$randomfile"`
						echo "$nombrebase" >> "$ruta"/.historico.mus
						previo="$randomfile"
						sleep 0.5
						$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &						
						minfin=`echo $(($minini + $segundos/60))`
						hfin=`echo $((($hini*60+$minfin)/60))`	
						mix=`cat $HOME/.gradio/data/mix.txt`
						mezcla=`echo $segundos - $mix|bc`
						lazorepite=`cat $HOME/.gradio/data/tmp/repitiendo`
						.  $HOME/.gradio/bin/panico.sh & 
						if [[ $estadotv = 1 && $logo = 1 ]]; then
						         $HOME/.gradio/bin/logopersiste.sh $mezcla &
					        fi
						sleep $mezcla
		                                modo=`cat $HOME/.gradio/data/tmp/modo`
		                                siguiente=`ps -x|grep -v grep|grep .gradio/bin/siguiente.sh`
		                                fadeout=`ps -x|grep -v grep|grep .gradio/bin/fadeoutparrilla.sh`
		                                if [[ $playinginter = "1" ]]; then  $HOME/.gradio/data/panel/playfininter.sh; fi 
		                                if [[ $modo = 0 && $siguiente = "" ]]; then
		                              		sleep $mix
			                              	$HOME/.gradio/bin/detenermanual4.sh GR4
		                                fi
					else #Sin fundido?? 
						if [[ `cat $HOME/.gradio/data/tmp/pisador` = 1 && $intercultural = "" ]]; then  
							avanti=`echo "$randomfile"|grep -i avance`
							if [ "$avanti" = "" ]; then 				
								xterm -iconic  -fg Black -bg Yellow -title "Pisador" -geometry 40x1+0+0 -e $HOME/.gradio/data/panel/pisador.sh & 
							fi
						fi  
						minini=`date  +%-M`
						tiempo "$randomfile"
						$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
						cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
						if [[ $cdown != "" ]]; then
							killall -9 countdown.sh
						fi
						$HOME/.gradio/bin/countdown.sh &
						echo $espar > $HOME/.gradio/data/tmp/espar
						mplayer $device $tvopcion -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  $srtopcion -volume $volup -quiet -slave -input file="$fifofile"  "$randomfile"  > $HOME/.gradio/data/tmp/mstatus$porc 2>&1
						.  $HOME/.gradio/bin/panico.sh &
						logo=`cat $HOME/.gradio/data/tmp/tvlogo`
						if [[ $estadotv = 1 && $logo = 1 ]]; then
							$HOME/.gradio/bin/logopersiste.sh &
						fi
						previo="$randomfile"
						if [[ $playinginter = "1" ]]; then  $HOME/.gradio/data/panel/playfininter.sh; fi 
							modo=`cat $HOME/.gradio/data/tmp/modo`
							if [[ $modo = 0 ]]; then
								sleep $mix
								$HOME/.gradio/bin/detenermanual4.sh GR4
							fi

						fi 
					else
						echo "parece que $randomfile no existe"
					fi
				fi
				musfin=`date +%s`
				duramus=$(($musfin-$musini))
				if [ -s $HOME/.gradio/data/reporte/parrilla-`date +%Y-%d-%m` ]; then
				touch $HOME/.gradio/data/reporte/parrilla-`date +%Y-%d-%m`
				fi
				echo `date +%Y-%m-%d`,$musinicio,`echo $randomfile|sed s/","/"_"/g`,$duramus,segundos,musica >> $HOME/.gradio/data/reporte/parrilla-`date +%Y-%d-%m`.txt
				$HOME/.gradio/bin/tiempointercul.sh &
				$HOME/.gradio/bin/tiempocomerciales.sh & 
				echo $mix > $HOME/.gradio/data/mix			
				minfin=`date  +%-M`
				hfin=`date +%-H`
				espera=`cat $HOME/.gradio/data/tmp/stop`
				repitiendo=`cat $HOME/.gradio/data/tmp/repitiendo`
				while [[ $repitiendo = 1 ]]; do
					echo "GR repitiendo: ${nombrebase%.*}" > $HOME/.gradio/data/tmp/currentsong.txt
					echo "Gr repitiendo: ${nombrebase%.*}" > $HOME/CurrentSong.txt
					sleep 0.1
					repitiendo=`cat $HOME/.gradio/data/tmp/repitiendo`
				done
				espera=`cat $HOME/.gradio/data/tmp/stop`
				while [[ $espera = 1 ]]; do
					echo "GR4: \"Detenido al finalizar el tema\" Play para continuar" > $HOME/.gradio/data/tmp/currentsong.txt
					echo "GR4: \"Detenido al finalizar el tema\" Play para continuar" > $HOME/.gradio/data/tmp/currentcomercial.txt
					sleep 0.5
					espera=`cat $HOME/.gradio/data/tmp/stop`
					echo "1" > $HOME/.gradio/data/tmp/stopGR4
				done
				echo "0" > $HOME/.gradio/data/tmp/stopGR4

				########################################INICIO EVENTOS##############################
				echo "0" > $HOME/.gradio/data/tmp/porciento
				modo=`cat $HOME/.gradio/data/tmp/modo`
				if [[ $modo = 0 ]]; then
					sleep $mix
					$HOME/.gradio/bin/detenermanual4.sh GR4
				fi	
				cnelineas=`grep -c $ $HOME/.gradio/data/tmp/eventoslist`
				if [ -s $HOME/.gradio/data/tmp/eventoslist ]; then
					echo "+++++++++Inicio Reproducción Eventos++++++++++++++++"
					echo 1 > $HOME/.gradio/data/tmp/eventosplay
					minini=`date  +%-M`
					hini=`date +%-H`
					cnlinea=1 
					twitter=`cat $HOME/.gradio/data/tmp/twidge`
					if [[ $twitter = 1 ]]; then 
						echo "Ahora emitiendo Eventos"|twidge update &
					fi
				while [[ $cnelineas -ge 1 ]]; do
					comercial=`head -1 $HOME/.gradio/data/tmp/eventoslist|sed '$s/\(^[^\t]*\).*$/\1/'` #Considera el tiempo`
					sed -i "1d" $HOME/.gradio/data/tmp/eventoslistwebg3
					PlugLineInGRadio=`echo $comercial|awk -F"|" '{ print $1 }'|grep PlugLineInGradio|awk -F" " '{ print $NF }'`
					
					echo "comercial evento:" $comercial
					nombrebase=`echo "$comercial" |awk -F"/" '{print $NF}'`  #$comercial  
					comini=`date +%s`
					cominicio=`date +%H:%M:%S`
					echo "Evento: ${nombrebase%.*}" > $HOME/.gradio/data/tmp/currentsong.txt;
					echo "Evento: ${nombrebase%.*}" > $HOME/CurrentSong.txt
					echo "Evento: ${nombrebase%.*}" > $HOME/.gradio/data/tmp/currentcomercial.txt;
					#echo "<font size="1" color="red"><b>${nombrebase%.*}</b></font>" > $HOME/.gradio/data/tmp/currentsongweb;

							sleep 0.2
									cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
									if [[ $cdown != "" ]]; then
									killall -9 countdown.sh
									fi
				############## HORA
					lista=`echo $comercial|awk -F"|" '{ print $1 }'|awk -F"." '{ print $NF }'`
					#echo "lista: "$lista
					if [[ $comercial = "Hora" && $previo != "$comercial" ]]; then	## Es hora?
						twitter=`cat $HOME/.gradio/data/tmp/twidge`
						mix=`cat $HOME/.gradio/data/mix.txt`
						nombrebase="Hora"
						echo "Hora" > $HOME/.gradio/data/tmp/currentsong.txt 
						#echo "Hora" > $HOME/.gradio/data/tmp/currentsongweb
						echo "0" > $HOME/.gradio/data/tmp/porciento
						if [[ $twitter = 1 ]]; then 
							echo "Ahora emitiendo la hora"|twidge update & 
						fi
						echo "Hora" > $HOME/CurrenSong.txt
						cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
						if [[ $cdown != "" ]]; then
							killall -9 countdown.sh
						fi
						echo "Hora" > $HOME/.gradio/data/tmp/avance
						echo "<font color='red' size='24'><b>Hora</b></font>" > $HOME/.gradio/data/tmp/avanceweb
						sleep 0.1
						$HOME/.gradio/bin/GR_ClientSocketComercial.gambas &
						
							desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
							if [[ $desiguiente = 0 && $mix > 1 ]]; then
								sleep $(($mix-2)) 
							fi
						xterm -iconic  -fg Green -bg DarkBlue -title "hora" -geometry 40x1-0+0  -e $HOME/.gradio/data/panel/hora.sh
						sed -i "1d" $HOME/.gradio/data/tmp/eventoslist
						previo="$randomfile"
						desiguiente=0
						modo=`cat $HOME/.gradio/data/tmp/modo`
						if [[ $modo = 0 ]]; then
							sleep $mix
							$HOME/.gradio/bin/detenermanual4.sh GR4
						fi
				############## PlugLineInGRadio
					elif [[ $PlugLineInGRadio -gt 0 ]]; then					
						pactl load-module module-loopback latency_msec=5
						echo "00:00:$PlugLineInGRadio"  > $HOME/.gradio/data/tmp/duracion
						$HOME/.gradio/bin/countdown.sh &
						sed -i "1d" $HOME/.gradio/data/tmp/eventoslist
						sleep $PlugLineInGRadio
						pactl unload-module module-loopback
					
					elif [[ $lista = "gradio" && $previo != "$comercial" ]]; then
						cp "$comercial" $HOME/.gradio/data/tmp/playlist4
						$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
						sed -i "1d" $HOME/.gradio/data/tmp/eventoslist
					else ##No es hora ni lista
						internet=`echo "$comercial"|grep "http://"`
						internets=`echo "$comercial"|grep "https://"`
						echo "$comercial" > $HOME/.gradio/data/tmp/tmpweb
						ejecutar=`echo $comercial|grep 123456789098765432100`
						comando=`echo $comercial|awk -F"&&" '{print $2}'`
						if [[ $internet != "" || $internets != "" ]]; then
							echo "00:00:"`echo "$comercial"|awk '{print $4}'`  > $HOME/.gradio/data/tmp/duracion
							$HOME/.gradio/bin/countdown.sh &
							tiempostr=`echo $comercial|awk -F " " {'print $4'}`
							url=`echo $comercial|awk -F " " {'print $5'}`
							timeout $tiempostr mplayer $device $tvopcion -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  $srtopcion -volume $volup -quiet -slave -input file=$HOME/.gradio/data/tmp/slave.txt $url #> /dev/null 2>&1 &
							.  $HOME/.gradio/bin/panico.sh &
							previo="$comercial"
							sed -i "1d" $HOME/.gradio/data/tmp/eventoslist
						else		
							if [[ $ejecutar = "" ]]; then
								tiempo "$comercial"
								cdown=`ps -x|grep -v grep|grep .gradio/bin/countdown.sh`
								if [[ $cdown != "" ]]; then
									killall -9 countdown.sh
								fi
								$HOME/.gradio/bin/countdown.sh &
								mplayer $device $tvopcion -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  $srtopcion -volume $volup -quiet -slave -input file=$HOME/.gradio/data/tmp/slave.txt  "$comercial" > $HOME/.gradio/data/tmp/mstatus 2>&1 &
								.  $HOME/.gradio/bin/panico.sh &
								sed -i "1d" $HOME/.gradio/data/tmp/eventoslist
								cnlineas=`grep -c $ $HOME/.gradio/data/tmp/eventoslist`
								fundidocom=`cat $HOME/.gradio/data/tmp/fundidocomerciales`
								espera=$(($segundos-$fundidocom))
								echo "espera: $espera"
								sleep $espera
								previo="$comercial"
							else
								source $comando
							fi
						fi
						cnelineas=`grep -c $ $HOME/.gradio/data/tmp/eventoslist`
						comfin=`date +%s`
						duracion=$(( $comfin - $comini ))
						if [ -s $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m` ]; then
							touch $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m`
						fi
						echo `date +%Y-%m-%d`,$cominicio,`echo "$comercial"|sed s/","/"_"/g`,$duracion,segundos,eventos >> $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m`.txt #Reporte comerciales
					fi  #No es Hora
					done
				fi
				echo "Mensajes auxiliares GR" > $HOME/.gradio/data/tmp/currentcomercial.txt;
				echo 0 > $HOME/.gradio/data/tmp/eventosplay
				#echo "+++++++++Fin Reproducción Eventos++++++++++++++++"
				################################### FIN EVENTOSS #####################################

				################################### INICIO COMERCIALES ###############################
			modo=`cat $HOME/.gradio/data/tmp/modo`
			if [[ $modo = 0 ]]; then
				sleep $mix
				$HOME/.gradio/bin/detenermanual4.sh GR4
			fi
			iniespaciop=`cat $HOME/.gradio/data/tmp/espacio`
			cnlineas=`grep -c $ $HOME/.gradio/data/tmp/comercialeslist4`
			echo "0" > $HOME/.gradio/data/tmp/porciento
			if [ -s $HOME/.gradio/data/tmp/comercialeslist4 ]; then
				echo "cnlineas comerciales: "$cnlineas
				minini=`date  +%-M`
				hini=`date +%-H`
				cnlinea=1 
				desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
				if [[ $desiguiente = 0 && $mix > 0 ]]; then
					sleep $(($mix-1))
				fi

				if [[ $iniespaciop = 1 ]]; then
					$HOME/.gradio/data/panel/playinicioespacio.sh 
					sleep 1
					iniespaciop=3
				fi
				echo "0" > $HOME/.gradio/data/tmp/porciento
				twitter=`cat $HOME/.gradio/data/tmp/twidge`
				if [[ $twitter = 1 ]]; then 
					echo "Ahora emitiendo Comerciales"|twidge update &
					xterm -iconic  -fg Green -bg DarkBlue -title "Clima" -geometry 40x1-0+0  -e $HOME/.gradio/bin/tiempo-clima.sh &
				fi
				while [[ $cnlineas -ge 1 ]]; do
					comercial=`head -1 $HOME/.gradio/data/tmp/comercialeslist4|sed '$s/\(^[^\t]*\).*$/\1/'|sed '$s/\(^[^\t]*\).*$/\1/'|sed 's/[[:blank:]]*$//'` #selecciona primer campo de \t y quita espacios en blanco al final
					echo "comercial:"  $comercial
					nombrebase=`echo "$comercial" |awk -F"/" '{print $NF}'`
					comini=`date +%s`
					cominicio=`date +%H:%M:%S`
					echo "${nombrebase%.*}" > $HOME/.gradio/data/tmp/currentsong.txt;
					echo "${nombrebase%.*}" > $HOME/CurrentSong.txt
					echo "${nombrebase%.*}" > $HOME/.gradio/data/tmp/currentcomercial.txt;
					#echo "<font size="1" color="red"><b>${nombrebase%.*}</b></font>" > $HOME/.gradio/data/tmp/currentsongweb;
					tiempo "$comercial"
					echo "tiempo comercial: "$segundos
					killall -9 countdown.sh
					$HOME/.gradio/bin/countdown.sh &
					mplayer $device -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  $tvopcion -volume $volup -quiet -slave -input file=$HOME/.gradio/data/tmp/slave.txt  "$comercial"  > $HOME/.gradio/data/tmp/mstatus 2>&1 &
					.  $HOME/.gradio/bin/panico.sh &
					previo="$comercial"
					sed -i "1d" $HOME/.gradio/data/tmp/comercialeslist4
					cnlineas=`grep -c $ $HOME/.gradio/data/tmp/comercialeslist4`
					fundidocom=`cat $HOME/.gradio/data/tmp/fundidocomerciales`
					$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
					espera=$(($segundos-$fundidocom + 1))
					sleep $espera
					comfin=`date +%s`
					duracion=$(( $comfin - $comini ))
					if [ -s $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m` ]; then
						touch $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m`
					fi
					echo `date +%Y-%m-%d`,$cominicio,`echo "$comercial"|sed s/","/"_"/g`,$duracion,segundos,comerciales >> 		$HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m`.txt #Reporte comerciales
				done
			fi
			echo "0" >  $HOME/.gradio/data/tmp/desiguiente
			if [[ $iniespaciop = 3 ]]; then
				sleep 1
				$HOME/.gradio/data/panel/playfinespacio.sh #xterm -iconic  -fg Green -bg Red -title "$nombrebase"  -geometry 40x1-0+0 -e 
			fi
			espera=`cat $HOME/.gradio/data/tmp/stopcomercial`
			while [[ $espera = 1 ]]; do
				echo "GR4: \"Detenido al finalizar el comercial\" Play para continuar" > $HOME/.gradio/data/tmp/currentsong.txt
				echo "GR4: \"Detenido al finalizar el comercial\" Play para continuar" > $HOME/.gradio/data/tmp/currentcomercial.txt
				sleep 1
				espera=`cat $HOME/.gradio/data/tmp/stopcomercial`
			done
			echo "Mensajes auxiliares GR" > $HOME/.gradio/data/tmp/currentcomercial.txt;
			################################### FIN COMERCIALES #####################################

			########################################INICIO EVENTOS CON ESPERA #######################
			modo=`cat $HOME/.gradio/data/tmp/modo`
			if [[ $modo = 0 ]]; then
				sleep $mix
				$HOME/.gradio/bin/detenermanual4.sh GR4
			fi
			cnelineas=`grep -c $ $HOME/.gradio/data/tmp/eventos-esperalist`
			if [ -s $HOME/.gradio/data/tmp/eventos-esperalist ]; then
				minini=`date  +%-M`
				hini=`date +%-H`
				cnlinea=1 
				twitter=`cat $HOME/.gradio/data/tmp/twidge`
				if [[ $twitter = 1 ]]; then 
					echo "Ahora emitiendo Eventos con espera"|twidge update &
				fi
			while [[ $cnelineas -ge 1 ]]; do
				comercial=`head -1 $HOME/.gradio/data/tmp/eventos-esperalist|sed '$s/\(^[^\t]*\).*$/\1/'|sed 's/[[:blank:]]*$//'` #selecciona primer campo de \t y quita espacios en blanco al final
				nombrebase=$comercial 
				nombrebaseC=`echo "$comercial" |awk -F"/" '{print $NF}'`
				comini=`date +%s`
				cominicio=`date +%H:%M:%S`
				echo "Evento: ${nombrebaseC%.*}" > $HOME/.gradio/data/tmp/currentsong.txt;
				echo "Evento: ${nombrebaseC%.*}" > $HOME/CurrentSong.txt
				echo "Evento: ${nombrebaseC%.*}" > $HOME/.gradio/data/tmp/currentcomercial.txt;
				#echo "<font size="1" color="red"><b>${nombrebaseC%.*}</b></font>" > $HOME/.gradio/data/tmp/currentsongweb;
				sed -i "1d" $HOME/.gradio/data/tmp/eventos-esperalistwebcomercialeslist
				sed -i "1d" $HOME/.gradio/data/tmp/eventos-esperalistwebg3
				sleep 0.2
				killall -9 countdown.sh
				lista=`echo $comercial|awk -F"|" '{ print $1 }'|awk -F"." '{ print $NF }'`
				if [[ $comercial = "Hora" && $previo != "$comercial" ]]; then	## Es hora?
					twitter=`cat $HOME/.gradio/data/tmp/twidge`
					mix=`cat $HOME/.gradio/data/mix.txt`
					nombrebase="Hora"
					echo "Hora" > $HOME/.gradio/data/tmp/currentsong.txt 
					#echo "Hora" > $HOME/.gradio/data/tmp/currentsongweb
					echo "0" > $HOME/.gradio/data/tmp/porciento
					if [[ $twitter = 1 ]]; then 
						echo "Ahora emitiendo la hora"|twidge update & 
					fi
					echo "Hora" > $HOME/CurrenSong.txt
					killall -9 countdown.sh
					echo "Hora" > $HOME/.gradio/data/tmp/avance
					echo "<font color='red' size='24'><b>Hora</b></font>" > $HOME/.gradio/data/tmp/avanceweb
					sleep 0.1
					$HOME/.gradio/bin/GR_ClientSocketComercial.gambas &
					desiguiente=`cat $HOME/.gradio/data/tmp/desiguiente`
					if [[ $desiguiente = 0 && $mix > 1 ]]; then
						sleep $(($mix-2)) 
					fi
					xterm -iconic  -fg Green -bg DarkBlue -title "hora" -geometry 40x1-0+0  -e $HOME/.gradio/data/panel/hora.sh
					sed -i "1d" $HOME/.gradio/data/tmp/eventos-esperalist
					previo="$randomfile"
					desiguiente=0
					modo=`cat $HOME/.gradio/data/tmp/modo`
					if [[ $modo = 0 ]]; then
						sleep $mix
						$HOME/.gradio/bin/detenermanual4.sh GR4
					fi
				elif [[ $lista = "gradio" && $previo != "$comercial" ]]; then
					cp "$comercial" $HOME/.gradio/data/tmp/playlist4
					$HOME/.gradio/bin/GR_ClientSocketPlayList.gambas &
					sed -i "1d" $HOME/.gradio/data/tmp/eventos-esperalist
				else ##No es hora
					internet=`echo "$comercial"|grep "http://"`
					internets=`echo "$comercial"|grep "https://"`
					echo "$comercial" > $HOME/.gradio/data/tmp/tmpweb
					ejecutar=`echo $comercial|grep 123456789098765432100`
					comando=`echo $comercial|awk -F"&&" '{print $2}'`
					if [[ $internet != "" || $internet != "" ]]; then
						echo "00:00:"`echo "$comercial"|awk '{print $4}'`  > $HOME/.gradio/data/tmp/duracion
						$HOME/.gradio/bin/countdown.sh &
						mplayer $device $tvopcion -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  $srtopcion -volume $volup -quiet -slave -input file=$HOME/.gradio/data/tmp/slave.txt $comercial > $HOME/.gradio/data/tmp/mstatus
						previo="$comercial"
						sed -i "1d" $HOME/.gradio/data/tmp/eventos-esperalist
					else		
						if [[ $ejecutar = "" ]]; then
							tiempo "$comercial"
							killall -9 countdown.sh
							$HOME/.gradio/bin/countdown.sh &
							mplayer $device $tvopcion -vf bmovl=0:0:$HOME/.gradio/data/tmp/logo.fifo  $srtopcion -volume $volup -quiet -slave -input file=$HOME/.gradio/data/tmp/slave.txt  "$comercial" > $HOME/.gradio/data/tmp/mstatus 2>&1 &
							.  $HOME/.gradio/bin/panico.sh &
							sed -i "1d" $HOME/.gradio/data/tmp/eventos-esperalist
							cnlineas=`grep -c $ $HOME/.gradio/data/tmp/eventos-esperalist`
							fundidocom=`cat $HOME/.gradio/data/tmp/fundidocomerciales`
							espera=$(($segundos-$fundidocom))
							sleep $espera
							previo="$comercial"
						else
							source $comando
						fi
					fi
					cnelineas=`grep -c $ $HOME/.gradio/data/tmp/eventos-esperalist`
					comfin=`date +%s`
					duracion=$(( $comfin - $comini ))
					if [ -s $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m` ]; then
						touch $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m`
					fi
					echo `date +%Y-%m-%d`,$cominicio,`echo "$comercial"|sed s/","/"_"/g` ,$duracion,segundos,"eventos en espera" >> $HOME/.gradio/data/reporte/comercial-`date +%Y-%d-%m`.txt #Reporte comerciales
				fi ## No es Hora
			done
			fi
			echo "Mensajes auxiliares GR" > $HOME/.gradio/data/tmp/currentcomercial.txt;
			################################### FIN EVENTOS CON ESPERA #####################################
			$HOME/.gradio/bin/GR_ClientSocketCom.gambas &
			nlinea=$(($nlinea+1))
		done 
		else
		sleep 3
		fi	
		hora1=`date  +%-H`
		saliolazo=1
		semiautomatico=`cat $HOME/.gradio/data/tmp/listavacia`
		if [[ $semiautomatico = "1" ]]; then
			echo "Visor de Temas Musicales" > $HOME/.gradio/data/tmp/currentsong.txt
			echo "G Radio: Parece estar en modo semiautomático" > $HOME/.gradio/data/tmp/currentcomercial.txt
		else 
			echo "Visor de Temas Musicales" > $HOME/.gradio/data/tmp/currentsong.txt
			echo "G Radio: No existe parrilla a las $hora horas" > $HOME/.gradio/data/tmp/currentcomercial.txt
		fi
	done
done
exit 0
