#!/bin/bash 

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  	  #
#	    Instalador  Última actualización: 04-Jun-2019		  #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	    		  #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.								  #
#									  #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.							  #
#									  #
############################################################################# 

############################################################################# 
#                G Radio - Versión 4.12 - Ebano                             # 
#                            Febrero 2020                                   #
############################################################################# 
function folders {
	if [[ -d /usr/share/mplayer/skins/clearplayer ]];then sudo cp $ruta_install/mplayer/*png /usr/share/mplayer/skins/clearplayer;fi
	sudo cp $ruta_install/bin/cue /usr/local/bin/cue
	sudo cp $ruta_install/bin/buscar /usr/local/bin/buscar
	sudo chmod 755 /usr/local/bin/buscar
	sudo chmod 755 /usr/local/bin/cue
	cp -R $ruta_install/.mplayer $HOME

	## Si no existen las carpetas para G Radio las crea
	test ! -d $HOME/.gradio/ && mkdir $HOME/.gradio
	test ! -d $HOME/"G Radio"/ && mkdir $HOME/"G Radio"
	test ! -d $HOME/"G Radio"/musica/ && mkdir $HOME/"G Radio"/musica
	test ! -d $HOME/"G Radio"/comerciales/ && mkdir $HOME/"G Radio"/comerciales && cp $ruta_install/comerciales/* $HOME/"G Radio"/comerciales/
	test ! -d $HOME/"G Radio"/efectos/ && mkdir $HOME/"G Radio"/efectos && cp  $ruta_install/efectos/* $HOME/"G Radio"/efectos/
	test ! -d $HOME/"G Radio"/avances/ && mkdir $HOME/"G Radio"/avances
	test ! -d $HOME/"G Radio"/fin-espacio-pub/ && mkdir $HOME/"G Radio"/fin-espacio-pub && cp -R $ruta_install/fin-espacio-pub/* $HOME/"G Radio"/fin-espacio-pub/
	test ! -d $HOME/"G Radio"/inicio-espacio-pub/ && mkdir $HOME/"G Radio"/inicio-espacio-pub && cp  -R $ruta_install/inicio-espacio-pub/* $HOME/"G Radio"/inicio-espacio-pub/
	test ! -d $HOME/"G Radio"/logo/ && mkdir $HOME/"G Radio"/logo && cp  -R $ruta_install/logo/* $HOME/"G Radio"/logo/
	test ! -d $HOME/"G Radio"/Intercultural/ && mkdir $HOME/"G Radio"/Intercultural && cp -R $ruta_install/Intercultural/* $HOME/"G Radio"/Intercultural/

	## Copia los archivos binarios
	test -d $HOME/.gradio/bin/ && mv $HOME/.gradio/bin $HOME/.gradio/bin-respaldo-"`date +%d-%m-%Y`"
	cp -R $ruta_install/bin $HOME/.gradio

	## Copia los archivos de datos
	test -d $HOME/.gradio/data/ && test ! -d $HOME/.gradio/data/botonera/ && cp -R $ruta_install/data/botonera  $HOME/.gradio/data
	test -d $HOME/.gradio/data/ && test ! -d $HOME/.gradio/data/eventos-espera/ && cp -R $ruta_install/data/eventos-espera  $HOME/.gradio/data
	test ! -d $HOME/.gradio/data/ && cp -R $ruta_install/data $HOME/.gradio

	## Logo
	mkdir $HOME/.gradio/img
	mkfifo $HOME/.gradio/data/tmp/slave.txt
	mkfifo $HOME/.gradio/data/tmp/logo.fifo
	cp  $ruta_install/instalar/*png  $HOME/.gradio/img


	## Acceso Directo
	test -d $HOME/Desktop/ && escritorio="Desktop"
	test -d $HOME/Escritorio/ && escritorio="Escritorio"

	touch $HOME/$escritorio/"G Radio".desktop
	echo "#!/usr/bin/env xdg-open" > $HOME/$escritorio/"G Radio".desktop

	echo "[Desktop Entry]" >> $HOME/$escritorio/"G Radio".desktop
	echo "Version=1.0" >> $HOME/$escritorio/"G Radio".desktop
	echo "Type=Application" >> $HOME/$escritorio/"G Radio".desktop
	echo "Terminal=false" >> $HOME/$escritorio/"G Radio".desktop
	echo "Icon[es_EC]=$HOME/.gradio/img/gradio.png" >> $HOME/$escritorio/"G Radio".desktop
	echo "Name[es_EC]=G Radio" >> $HOME/$escritorio/"G Radio".desktop
	echo "Exec=$HOME/.gradio/bin/lanzador.sh" >> $HOME/$escritorio/"G Radio".desktop
	echo "Comment[es_EC]=G Radio" >> $HOME/$escritorio/"G Radio".desktop
	echo "Name=G Radio" >> $HOME/$escritorio/"G Radio".desktop
	echo "Comment=G Radio" >> $HOME/$escritorio/"G Radio".desktop
	echo "Icon=$HOME/.gradio/img/gradio.png" >> $HOME/$escritorio/"G Radio".desktop
	echo "Categories=AudioVideo;Audio" >> $HOME/$escritorio/"G Radio".desktop
	chown -R $usuario:$usuario $HOME/.gradio
	chmod -R 755 $HOME/.gradio
	chmod 755 $HOME/$escritorio/"G Radio".desktop
	test ! -d $HOME/.local/share/applications && mkdir $HOME/.local/share/applications
	cp $HOME/$escritorio/"G Radio".desktop $HOME/.local/share/applications/"G Radio".desktop
	sudo ln -s $HOME/.gradio/data/www /var/www/html/gradio
	
	test ! -d $HOME/.gradio/data/panel/botonera/ && mkdir $HOME/.gradio/data/panel/botonera
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX1/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX1
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX2/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX2
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX3/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX3
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX4/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX4
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX5/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX5
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX6/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX6
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX7/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX7
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX8/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX8
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX9/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX9
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX10/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX10
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX11/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX11
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX12/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX12
	test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FXTV/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FXTV	

	if [[ ! -f $HOME/.gradio/bin/GMain.gambas ]]; then
		mascara=`ls $HOME/.gradio/bin/mascara|head -n 1`
		ln -s $HOME/.gradio/bin/mascara/"$mascara" $HOME/.gradio/bin/GMain.gambas
	fi	
}

usuario=`whoami`
ruta_install=`pwd|sed s/"\/instalar"//`
apte=`which apt`
pacmi=`which pacman`
dnfe=`which dnf`
if [[ $apte != "" ]];then
	#if [[ `which gambas` ]]; then sudo apt remove gambas3 -y;fi	
	#if [[ ! `ls /etc/apt/sources.list.d/|grep gambas3` ]]; then sudo add-apt-repository ppa:gambas-team/gambas3;fi
	#sleep 3
	sudo apt update
	sudo apt install mplayer -y
	sudo apt install ffmpeg2theora -y
	sudo apt install ffmpeg -y
	sudo apt install xterm -y
	sudo apt install sox -y
	sudo apt install libsox-fmt-all -y
	sudo apt install gedit -y
	sudo apt install at -y
	sudo apt install imagemagick -y
	sudo apt install gambas3 -y
	sudo apt install gambas3-gb-qt5 -y
	sudo apt install gambas3-gb-qt5-webkit -y
	sudo apt install python3 -y
	sudo apt install python -y
	sudo apt install python3-pip -y
	sudo apt install mediainfo -y
	sudo apt install apache2 -y
	sudo apt install php -y
	sudo apt install audacity -y
	sudo apt install jq -y
	sudo apt install socat -y
	sudo apt install pqiv -y
	sudo apt install mpv -y

	sudo pip3 install pandas
	sudo pip3 install mplayer.py
	sudo chown -R $usuario:$usuario $HOME/.cache
	if [[ `which pip3` ]]; then
		pip3 install youtube-dl
	else
		pip install youtube-dl
	fi
	
	pulseaudiogr=`which pulseaudio`
	bcgr=`which bc`
	if [[ $pulseaudiogr = "" ]];then
	sudo apt install pulseaudio -y
	fi

	if [[ $bcgr = "" ]];then
	sudo apt install bc -y
	fi


	sudo /etc/init.d/apache2 restart

	zenity --info --text "Ha concluido el proceso de instalar GR, para ejecutar Gradio haga doble click en el ícono G en su $escritorio"

	exit 0
fi

if [[ $pacmi != "" ]];then
	sudo pacman -S --noconfirm mplayer
	sudo pacman -S --noconfirm ffmpeg2theora
	sudo pacman -S --noconfirm ffmpeg
	sudo pacman -S --noconfirm xterm
	sudo pacman -S --noconfirm sox 
	sudo pacman -S --noconfirm at
	sudo pacman -S --noconfirm imagemagick
	sudo pacman -S --noconfirm gambas3
	sudo pacman -S --noconfirm python3
	sudo pacman -S --noconfirm python-pip
	sudo pacman -S --noconfirm apache 
	sudo pacman -S --noconfirm php
	sudo pacman -S --noconfirm gambas3-gb-qt5-webkit
	sudo pacman -S --noconfirm audacity
	pip install youtube-dl
	sudo chown -R $usuario:$usuario $HOME/.cache
	sudo ln -s $HOME/.gradio/data/www /srv/http/gradio
	sudo systemctl enable httpd
	sudo systemctl restart httpd

	folders
 
	zenity --info --text "Ha concluido el proceso de instalar GR, para ejecutar Gradio haga doble click en el ícono G en su $escritorio"

	exit 0
fi

if [[ $dnfe != "" ]];then
	#if [[ `which gambas` ]]; then sudo dnf remove gambas3 -y;fi	
	#if [[ ! `ls /etc/dnf/sources.list.d/|grep gambas3` ]]; then sudo add-dnf-repository ppa:gambas-team/gambas3;fi
	#sleep 3
	sudo dnf update
	sudo dnf install http://download1.rpmfusion.org/free/fedora/rpmfusion-free-release-$(rpm -E %fedora).noarch.rpm http://download1.rpmfusion.org/nonfree/fedora/rpmfusion-nonfree-release-$(rpm -E %fedora).noarch.rpm -y
	sudo dnf install mplayer -y
	#sudo dnf install ffmpeg2theora -y
	sudo dnf install ffmpeg -y
	sudo dnf install xterm -y
	sudo dnf install sox -y
	#sudo dnf install libsox-fmt-all -y
	sudo dnf install gedit -y
	sudo dnf install at -y
	sudo dnf install ImageMagick -y
	sudo dnf install gambas3 -y
	sudo dnf install gambas3-gb-qt5 -y
	sudo dnf install gambas3-gb-qt5-webkit -y
	sudo dnf install python3 -y
	sudo dnf install python -y
	sudo dnf install python3-pip -y
	sudo dnf install mediainfo -y
	sudo dnf install httpd -y
	sudo dnf install php -y
	sudo dnf install audacity -y
	sudo dnf install jq -y
	sudo dnf install socat -y
	sudo dnf install https://github.com/rpmsphere/noarch/raw/master/r/rpmsphere-release-32-1.noarch.rpm -y
	sudo dnf install pqiv -y
	sudo dnf install mpv -y

	sudo pip3 install pandas
	sudo pip3 install mplayer.py
	sudo chown -R $usuario:$usuario $HOME/.cache
	if [[ `which pip3` ]]; then
		pip3 install youtube-dl
	else
		pip install youtube-dl
	fi
	
	pulseaudiogr=`which pulseaudio`
	bcgr=`which bc`
	if [[ $pulseaudiogr = "" ]];then
	sudo dnf install pulseaudio -y
	fi

	if [[ $bcgr = "" ]];then
	sudo dnf install bc -y
	fi

	folders
	
	sudo service httpd restart


	zenity --info --text "Ha concluido el proceso de instalar GR, para ejecutar Gradio haga doble click en el ícono G en su $escritorio"

	exit 0
fi
